#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "rlcif.h"
#include "utils.h"

typedef struct _instance_manager_t {
    instance_des_t * _local_all_instances;
    instance_des_t ** _local_inst_vect;
    int instancenum;
    int maxinstances;
} instance_manager_t;

#define m ((instance_manager_t *)ptr)

int _rlc_insert_instance (instance_des_t *  inst, void *ptr)
{
  int i;

    for (i=0; i<m->maxinstances && m->_local_inst_vect[i] != NULL; i++);
    if (i != m->maxinstances) {
	m->_local_inst_vect[i] = inst;
	inst->ides = i;
    } else {
	rlc_return_error_(inst->ides, TOO_MANY_INSTANCES, NULL);
    }
    inst->next = m->_local_all_instances;
    m->_local_all_instances = inst;
    m->instancenum ++;

    return i;
}

int _rlc_howmany_instance (void **ptr)
{
    return (m->instancenum);
}

void
_rlc_return_instance (instance_des_t *  inst, void *ptr)
{
  instance_des_t * app;

    if (inst == m->_local_all_instances)
	m->_local_all_instances = m->_local_all_instances->next;
    else {
	for (app = m->_local_all_instances;
	    app->next == inst || !app->next;
	    app = app->next);
	if (app->next == inst)
	    app->next = inst->next;
    }
    m->_local_inst_vect[inst->ides] = NULL;
    m->instancenum --;
}

instance_des_t * 
_rlc_getinstance(int pi, void *ptr)
{
    if (pi < m->maxinstances && m->_local_inst_vect[pi] &&
	m->_local_inst_vect[pi]->ides == pi)
	return (m->_local_inst_vect[pi]);
    rlc_internal_set_error_ (pi, NO_SUCH_INSTANCE, NULL);
    return (NULL);
}

int
_rlc_init_instance (int maxinstances, void **ptr)
{
  int i;
#define mm ((instance_manager_t **)ptr)

    if (((*ptr) = malloc(sizeof(instance_manager_t))) == NULL)
	return (rlc_return_error_ (-1, ALLOC_ERROR, NULL));
    if (((*mm)->_local_inst_vect = malloc(sizeof(instance_des_t *) *
	maxinstances)) == NULL) {
	free(*ptr);
	return (rlc_return_error_ (-1, ALLOC_ERROR, NULL));
    }
    (*mm)->instancenum = 0;
    (*mm)->maxinstances = maxinstances;
    (*mm)->_local_all_instances = NULL;

    for (i=0; i<(*mm)->maxinstances; i++) {
	(*mm)->_local_inst_vect[i] = NULL;
    }
    return (0);
}

int rlc_get_allinst(int pi, void *ptr)
{
  instance_des_t   *ip = NULL;
    assert(ptr != NULL);
    if (pi == GET_SESSION_START) {
	ip = m->_local_all_instances;
	NDEB(fprintf(stderr, "rlc_get_allinst GET_SESSION_START\n");)
    } else if (pi < m->maxinstances && pi >= 0 && m->_local_inst_vect[pi])
        ip = m->_local_inst_vect[pi]->next;
    if (!ip) {
        return(GET_SESSION_END);
    }
    NDEB(fprintf(stderr, "rlc_get_allinst returns %d\n", ip->ides);)
    return(ip->ides);
}

